//
//
// hello.H-bridge.45.c
//
// H-bridge hello-world
//
// Neil Gershenfeld
// 11/13/10
//
// (c) Massachusetts Institute of Technology 2010
// Permission granted for experimental and personal use;
// license for commercial sale available from MIT.
//

#include <avr/io.h>
#include <util/delay.h>

#define output(directions,pin) (directions |= pin) // set port direction for output
#define set(port,pin) (port |= pin) // set port pin
#define clear(port,pin) (port &= (~pin)) // clear port pin
#define pin_test(pins,pin) (pins & pin) // test for port pin
#define bit_test(byte,bit) (byte & (1 << bit)) // test for bit set

#define gate_delay() _delay_us(5) // delay between switching gates
#define on_delay() _delay_us(1) // PWM on time
#define fast_off_delay() _delay_us(1) // PWM fast off time
#define medium_off_delay() _delay_us(10) // PWM medium off time
#define slow_off_delay() _delay_us(20) // PWM slow off time
#define PWM_count 10000 // number of PWM cycles
#define cycle_count 5 // number of speed cycles

#define MOSFET_port PORTB // MOSFET port
#define MOSFET_direction DDRB // MOSFET direction
#define MOSFET_pin (1<<PB2)

int main(void) {
   //
   // main
   //
   static uint16_t count;
   // static uint8_t cycle;
   //
   // set clock divider to /1
   //
   CLKPR = (1 << CLKPCE);
   CLKPR = (0 << CLKPS3) | (0 << CLKPS2) | (0 << CLKPS1) | (0 << CLKPS0);
   //
   // initialize H-bridge pins
   //
   clear(MOSFET_port, MOSFET_pin);
   output(MOSFET_direction, MOSFET_pin);
   

   // test code:
   // set(MOSFET_port,MOSFET_pin);
   // _delay_ms(1000);
   // clear(MOSFET_port,MOSFET_pin);
   // _delay_ms(1000);

   // //Timer in Fast PWM mode
   // TCCR0A = _BV(COM0A1) | _BV(WGM01) | _BV(WGM00);
   // TCCR0B = _BV(CS01); //| _BV(CS01); //PWM base frequency is 4.7KHz

   //Timer in Phase Correct PWM mode
   TCCR0A = _BV(COM0A1) | _BV(WGM00);
   TCCR0B = _BV(CS01); //| _BV(CS01); //PWM base frequency is 4.7KHz

   //initial duty cycle
   OCR0A = 0;

   //
   // main loop
   //
   while (1) {
      // OCR0A = 255;
      // _delay_ms(500);
      // OCR0A = 0;
      // _delay_ms(500);

      OCR0A = 255;
      // for (count = 150; count < 255; count++) {
      //    OCR0A = count;
      //    _delay_ms(500);
      // }

      // for (count = 255; count > 150; count--) {
      //    OCR0A = count;
      //    _delay_ms(500);
      // }



   }
}
      // for (cycle = 0; cycle < cycle_count; ++cycle) {
      //    //
      //    // turn right slow
      //    //
      //    clear(MOSFET_port, GLN);
      //    set(MOSFET_port, GRN);
      //    gate_delay();
      //    for (count = 0; count < PWM_count; ++count) {
      //       set(MOSFET_port, GLP);
      //       on_delay();
      //       clear(MOSFET_port, GLP);
      //       slow_off_delay();
      //       }
      //    //
      //    // turn left slow
      //    //
      //    clear(MOSFET_port, GRN);
      //    set(MOSFET_port, GLN);
      //    gate_delay();
      //    for (count = 0; count < PWM_count; ++count) {
      //       set(MOSFET_port, GRP);
      //       on_delay();
      //       clear(MOSFET_port, GRP);
      //       slow_off_delay();
      //       }
      //    }
      // for (cycle = 0; cycle < cycle_count; ++cycle) {
      //    //
      //    // turn right medium 
      //    //
      //    clear(MOSFET_port, GLN);
      //    set(MOSFET_port, GRN);
      //    gate_delay();
      //    for (count = 0; count < PWM_count; ++count) {
      //       set(MOSFET_port, GLP);
      //       on_delay();
      //       clear(MOSFET_port, GLP);
      //       medium_off_delay();
      //       }
      //    //
      //    // turn left medium
      //    //
      //    clear(MOSFET_port, GRN);
      //    set(MOSFET_port, GLN);
      //    gate_delay();
      //    for (count = 0; count < PWM_count; ++count) {
      //       set(MOSFET_port, GRP);
      //       on_delay();
      //       clear(MOSFET_port, GRP);
      //       medium_off_delay();
      //       }
      //    }
      // for (cycle = 0; cycle < cycle_count; ++cycle) {
      //    //
      //    // turn right fast
      //    //
      //    clear(MOSFET_port, GLN);
      //    set(MOSFET_port, GRN);
      //    gate_delay();
      //    for (count = 0; count < PWM_count; ++count) {
      //       set(MOSFET_port, GLP);
      //       on_delay();
      //       clear(MOSFET_port, GLP);
      //       fast_off_delay();
      //       }
      //    //
      //    // turn left fast
      //    //
      //    clear(MOSFET_port, GRN);
      //    set(MOSFET_port, GLN);
      //    gate_delay();
      //    for (count = 0; count < PWM_count; ++count) {
      //       set(MOSFET_port, GRP);
      //       on_delay();
      //       clear(MOSFET_port, GRP);
      //       fast_off_delay();
      //       }
      //    }
      // }